import java.util.*;

public class Hanoi {

    private final static int START = 0;  // Jn
    private final static int END = 1;    // I
    private final static int VIA = 2;    // oR

    private int size;                    // ̃TCY
    private Player player;

    public Hanoi(int size){
        this.size = size;
        
        player = new Player();
    }

    // Q[̃C[`
    public void startGame(){
        HanoiTowers towers = new HanoiTowers(size, START);

        System.out.println("nmC̓");
        towers.print();
        System.out.println(START + "  " + END + " ֈړĂ\n");

        do{
            boolean result = player.nextStep(towers);
            towers.print();

            if(!result){
                solve(new HanoiTowers(size, START), size, START, END, VIA);
                return;
            }
        }while(!towers.checkCompletion(END));

        System.out.println("܂\n߂łƂ܂");
    }

    // nmC̓
    private HanoiTowers solve(HanoiTowers towers, int n, int start, int end, int via){
        if(n > 0){
            // n-1 oRɈړ
            towers = solve(towers, n-1, start, via, end);
            
            // n ڂړI̓Ɉړ
            towers.move(start, end);
            System.out.println("Move " + start + " to " + end);
            towers.print();

            try{
                Thread.sleep(500);
            }catch(Exception e){}

            // n-1 oRړI̓Ɉړ
            towers = solve(towers, n - 1, via, end, start);
        }
        return towers;
    }

    public static void main(String[] args){
        if(args.length < 1){
            System.out.println("Usage: java Hanoi [~Ղ̖]");
            return;
        }

        Hanoi hanoi = new Hanoi(Integer.parseInt(args[0]));
        hanoi.startGame();
    }
}
