import java.util.*;

public class Tower implements Cloneable{

    private int maxSize;                    // ̃TCY
    private Stack piles;

    // Pile ̍ő喇w肵āATower 𐶐
    // ̂Ƃ initStackFlag  true Ȃ΁APile X^bNɐς
    public Tower(int maxSize, boolean initStackFlag){
        this.maxSize = maxSize;
        
        piles = new Stack();

        if(initStackFlag){
            for(int i = maxSize ; i > 0 ; i--){
                piles.push(new Pile(i, maxSize));
            }
        }
    }

    // Pile ̃X^bNw肵āATower 𐶐
    protected Tower(Stack piles, int maxSize){
        this.maxSize = maxSize;
        
        this.piles = (Stack)piles.clone();
    }

    // X^bN̐擪 Pile 폜A Pile ߂lƂĕԂ
    public Pile popPile(){
        return (Pile)piles.pop();
    }

    // X^bN̐擪ɂ Pile o
    // ̂Ƃ Pile ̓X^bN폜Ȃ
    public Pile peekPile(){
        return (Pile)piles.peek();
    }

    // X^bN̐擪 Pile 
    public void pushPile(Pile pile){
        piles.push(pile);
    }

    // pC̖Ԃ
    public int getNumber(){
        return piles.size();
    }

    // pC邩ǂԂ
    public boolean isEmpty(){
        return piles.empty();
    }
    
    // 𐶐
    public Object clone(){
        return new Tower(piles, maxSize);
    }

    public void print(){
        for(int i = 0 ; i < maxSize-1 ; i++){
            System.out.print(" ");
        }
        System.out.print("|");
        for(int i = 0 ; i < maxSize-1 ; i++){
            System.out.print(" ");
        }
    }
}
